/* Look for "delay-based version" to look for lines to change
 * to return to the duplicates-based version.
 */
#include <math.h>
#include "repairs.h"

initialize()
{
    int i, j, newrow;
    scanf ("seed: %d\n", &seed);
    if (seed == 0) (void) time(&seed); 
    firstseed = seed;
    srandom(seed);  
    printf ("seed: %d ", seed);
    scanf ("seed1: %d\n", &seed1);
    scanf ("repetitions: %d\n", &repetitions);
    scanf ("adapttimers: %d\n", &adapttimers);
    scanf ("edge: %d\n", &edgetype);
    scanf ("source: %d\n", &sourcetype);
    scanf ("sim: %d\n", &simtype);
    scanf ("lengths: %d\n", &lengthtype);
    scanf ("graph: %d\n", &graphtype);
    scanf ("rep_to_save: %d\n", &rep_to_save); 
      if (rep_to_save>2) --rep_to_save;
    scanf ("MaxDelay: %f\n", &MaxDelay);
    scanf ("MaxDups: %d\n", &MaxDups);
    scanf ("MaxAveDelay: %f\n", &MaxAveDelay);
    scanf ("MaxAveDups: %f\n", &MaxAveDups);
    scanf ("thresh: %d\n", &threshtype);
    scanf ("members: %d\n", &members);
    printf ("nodes: %d ", N);
    printf ("edges: %d ", M);
    printf ("wb_members: %d ", G);
    printf ("\n");
    printf ("MaxDelay: %5.3f ", MaxDelay);
    printf ("MaxDups: %3d ", MaxDups);
    printf ("MaxAveDelay: %5.3f ", MaxAveDelay);
    printf ("MaxAveDups: %5.3f ", MaxAveDups);
    printf ("graph type: %d ", graphtype);
    printf ("adaptive?: %d\n", adapttimers);
    printf ("errors: %d\n", ERRORS);
    if (graphtype > 0) {
      cloudnum = 1;
      if (CLOUD>=1) {
	newrow=graphtype;
        cloudnum += newrow;
      }
      for (i=2; i<=CLOUD; ++i) {
	newrow *= graphtype-1;
	cloudnum += newrow;
      }
    }
    if (simtype==3) {reqdelay=10000.0; reqdist=10000.0;}
    if (seed1 != 0) printf ("second seed: %d\n", seed1);
    initializelist();
    for (i=0; i<ERRORS; i++) {
      badedge[i].first=-1; 
      badedge[i].second=-1;
    }
    dropid=1;
    for (i=0; i<N; i++) wb[i] = -1;
    for (i=0; i<G; i++) {
      Member[i].wbtimer=0.0; 
      Member[i].wbnode=-1; 
      Member[i].ignorenack=0;
      Member[i].nstartplus=0.0; Member[i].nstopplus=0.0;
      Member[i].rstartplus=0.0; Member[i].rstartplus=0.0;
      Member[i].dupreqs=-1; Member[i].dupreps=-1;
      Member[i].avedupreqs=-1; Member[i].avedupreps=-1;
      Member[i].avereqdelay=-1; Member[i].averepdelay=-1;
      Member[i].maxreqdelay=0; Member[i].maxrepdelay=0;
      Member[i].maxdupreqs=0; Member[i].maxdupreps=0;
      Member[i].closest_req=0; Member[i].closest_rep=0;
      for (j=0; j<ERRORS; j++) {
        Member[i].wbstatus[j]=0;
        Member[i].disttosource[j]=-1;
	Member[i].backoff[j]=0;
	Member[i].backofftime[j]=0.0;
      }
      if (verbose9==1) 
       printf ("Node: %d C1: %6.2f C2: %6.2f D1: %6.2f D2: %6.2f\n", i,
	 NSTART + Member[i].nstartplus, NSTOP + Member[i].nstopplus,
	 RSTART + Member[i].rstartplus, RSTOP + Member[i].rstopplus);
    }
}

reinit()
{
    int i;  
    ++dropid;
    for (i=0; i<G; i++) {
      if (Member[i].wbstatus[errornum]==WASBAD) 
        Member[i].wbstatus[errornum]=BAD;
      if (Member[i].wbstatus[errornum]==BAD) {
       if (Member[i].dupreqs>Member[i].maxdupreqs)
	 Member[i].maxdupreqs=Member[i].dupreqs;
       if (Member[i].avedupreqs==-1) { 
	Member[i].avedupreqs= Member[i].dupreqs;}
       else 
	Member[i].avedupreqs=(1-WEIGHT)* Member[i].avedupreqs
		+WEIGHT*Member[i].dupreqs;
      }
      else if (Member[i].wbstatus[errornum]==GOOD) {
       if (Member[i].dupreps>Member[i].maxdupreps)
	 Member[i].maxdupreps=Member[i].dupreps;
       if ( Member[i].avedupreps==-1) { 
        Member[i].avedupreps= Member[i].dupreps;}
       else 
	Member[i].avedupreps=(1-WEIGHT)* Member[i].avedupreps
		+WEIGHT*Member[i].dupreps;
      }
      if (verbose8==1) printf 
	("node: %d ADelP: %4.2f ADelQ: %4.2f ADupQ: %4.2f ADupP: %4.2f\n", 
	i, Member[i].averepdelay, Member[i].avereqdelay,
	Member[i].avedupreqs, Member[i].avedupreps);
      Member[i].backoff[errornum]=0;
      Member[i].ignorenack=0;
      if (Member[i].wbstatus[errornum]==GOOD) 
        Member[i].disttosource[errornum]=-1;
      if (adapttimers==1) {
       if (Member[i].wbstatus[errornum]==GOOD) {
        /* modify RSTOP, depending on number of dup repairs.  */
        if (DUPS==0) {
		/*  This is the delay-based version. */
		if (Member[i].averepdelay >= 2*MaxAveDelay) {
		  Member[i].rstartplus -= 0.05;
		  if (Member[i].avedupreps < MaxAveDups - EPSILON)  
		    Member[i].rstopplus -= 0.1;
	        }
		else if (Member[i].avedupreps >= MaxAveDups) {
	   	  Member[i].rstopplus += 0.5;
		  if (Member[i].averepdelay < 2*MaxAveDelay - EPSILON)
		    Member[i].rstartplus += 0.05;
		}
		else if (Member[i].avedupreps < MaxAveDups - EPSILON &&
		  Member[i].averepdelay < MaxAveDelay - EPSILON)
		  Member[i].rstopplus -= 0.1;
	 }
	 else {
		/*  This is the duplicates-based version */
                if (Member[i].closest_rep==1) {
                   Member[i].rstopplus -= 0.1;
		   Member[i].closest_rep=0;
                }
	        if (Member[i].avedupreps>=MaxAveDups) {
	          Member[i].rstartplus += 0.1;
	          Member[i].rstopplus += 0.5;
	        }
		/*
		else if (Member[i].avedupreps < 0.5*MaxAveDups) {
		  Member[i].rstartplus -= 0.05;
		  Member[i].rstopplus -= 0.1;
		}
  	        else if (Member[i].avedupreps < MaxAveDups-EPSILON &&
		  Member[i].averepdelay > MaxAveDelay)
		    Member[i].rstopplus -= 0.1;
		*/
	        else if (Member[i].avedupreps < MaxAveDups-EPSILON) {
	          if (Member[i].averepdelay > MaxAveDelay)
	            Member[i].rstopplus -= 0.1;
	          if (Member[i].avedupreps < 0.25)
	            Member[i].rstartplus -= 0.05;
	        }
	        else Member[i].rstartplus += 0.05;
	}
       }
       else if (Member[i].wbstatus[errornum]==BAD) {
	/* modify NSTOP, depending on number of dup requests. */
	if (DUPS==0) {
		/*  This is the delay-based version. */
		if (Member[i].avereqdelay >= MaxAveDelay) {
		  Member[i].nstartplus -= 0.05;
		  if (Member[i].avedupreqs < MaxAveDups - EPSILON)  
		    Member[i].nstopplus -= 0.1;
	        }
		else if (Member[i].avedupreqs >= MaxAveDups) {
	   	  Member[i].nstopplus += 0.5;
		  if (Member[i].avereqdelay < MaxAveDelay - EPSILON)
		    Member[i].nstartplus += 0.05;
		}
		else if (Member[i].avedupreqs < MaxAveDups - EPSILON &&
		  Member[i].avereqdelay < MaxAveDelay - EPSILON)
		  Member[i].nstopplus -= 0.1;
	}
	else {
		/*  This is the duplicates-based version */
                if (Member[i].closest_req==1) {
                   Member[i].nstopplus -= 0.1;
		   Member[i].closest_req=0;
                }
		if (Member[i].avedupreqs>=MaxAveDups){
	          Member[i].nstartplus += 0.1;
	          Member[i].nstopplus += 0.5;
	        }
		/*
		else if (Member[i].avedupreqs < 0.5*MaxAveDups) {
		  Member[i].nstartplus -= 0.05;
		  Member[i].nstopplus -= 0.1;
		}
  	        else if (Member[i].avedupreqs < MaxAveDups-EPSILON &&
		  Member[i].avereqdelay > MaxAveDelay)
		    Member[i].nstopplus -= 0.1;
		*/
	        else if (Member[i].avedupreqs < MaxAveDups-EPSILON) { 
		  if (Member[i].avereqdelay > MaxAveDelay) 
		    Member[i].nstopplus -= 0.1;
		  if (Member[i].avedupreqs < 0.25) 
		    Member[i].nstartplus -= 0.05; 
		}
		else Member[i].nstartplus += 0.05;
	}
       }
      checkbounds(i);
      }
      Member[i].dupreps=-1; Member[i].dupreqs=-1;
      if (verbose9==1) 
       printf ("Node: %d C1: %6.2f C2: %6.2f D1: %6.2f D2: %6.2f\n", i,
	 NSTART + Member[i].nstartplus, NSTOP + Member[i].nstopplus,
	 RSTART + Member[i].rstartplus, RSTOP + Member[i].rstopplus);
    }
}

checkbounds(nodeno)
int nodeno;
{
/* check min and max values */
  if (Member[nodeno].rstartplus < MINRSTART-RSTART)
    Member[nodeno].rstartplus = MINRSTART-RSTART;
  else if (Member[nodeno].rstartplus > 0)
    Member[nodeno].rstartplus = 0;
  if (Member[nodeno].rstopplus < MINRSTOP-RSTOP) 
    Member[nodeno].rstopplus = MINRSTOP-RSTOP;
  else if (Member[nodeno].rstopplus > MAXRSTOP - RSTOP) 
    Member[nodeno].rstopplus = MAXRSTOP - RSTOP;
  if (Member[nodeno].nstartplus < MINNSTART-NSTART)
    Member[nodeno].nstartplus = MINNSTART-NSTART;
  else if (Member[nodeno].nstartplus > 0)
    Member[nodeno].nstartplus = 0;
  if (Member[nodeno].nstopplus < MINNSTOP-NSTOP) 
    Member[nodeno].nstopplus = MINNSTOP-NSTOP;
  else if (Member[nodeno].nstopplus > MAXNSTOP - NSTOP)
    Member[nodeno].nstopplus = MAXNSTOP - NSTOP;
}

initreq(nodeno)
int nodeno;
{
  Member[nodeno].closest_req=1;
  if (adapttimers==1) {
    Member[nodeno].nstartplus -= 0.05;
    checkbounds(nodeno);
  }
}

initrep(nodeno)
int nodeno;
{
  Member[nodeno].closest_rep=1;
  if (adapttimers==1) {
    Member[nodeno].rstartplus -= 0.05;
    checkbounds(nodeno);
  }
}

initializelist()
{
  int j;
  z = (struct node *) malloc(sizeof *z);
  z->next = z;
  for (j=0; j<N; j++) {
    adj[j] = z;
  }
}

/* Insert adds edge (i, j) to the graph. 
 * If "oldlength==0" then edge length is seconds is determined by the
 *   variable "lengthtype".  If "oldlength>0" then the edge length is
 *   seconds is determined by the variable "inserttype".
 * "Thresh" is the link threshold. 
 */
insert(i, j, oldlength, thresh)
  int i, j, oldlength, thresh;
{
  int length;
  float frac;
  struct node *t;
  if (i==j) printf ("Error: adding edge (%d, %d).\n", i, j);
  if (oldlength==0) {
    if (lengthtype==0 ) length=1;
    else if (lengthtype==1 ) {
	length = (int) ((10.0*random())/2147483647.0);
	if (length==0) length=1;
    }
  }
  else if (oldlength>0) {
      length=oldlength-(inserttype)+1;
      if (length<1) length=1;    
  }
  if (verbose4==1||verbose6==1)
    printf ("Adding (%d, %d) of length %d thresh %d\n", i, j, length, thresh); 
  t = (struct node *) malloc(sizeof *t);
  t->v = i; t->length=length; t->thresh=thresh; t->next = adj[j]; adj[j] = t;
  if (t->v==t->next->v)
    printf ("Error:  Adding edge (%d, %d) a second time.\n", j, i);
  t = (struct node *) malloc(sizeof *t);
  t->v = j; t->length=length; t->thresh=thresh; t->next = adj[i]; adj[i] = t;
  if (t->v==t->next->v)
    printf ("Error:  Adding edge (%d, %d) a second time.\n", i, j);
}

/* Edge returns 1 if edge (i, j) is in the graph. */
edge(i, j)
  int i, j;
{
  int notdone;
  struct node *t;
  /* printf ("Checking (%d, %d)\n", i, j); */
  notdone=1;
  t = adj[i];
  while (t != z && notdone) {
    if (t->v == j) notdone=0;
    else t = t->next;
  }
  if (notdone==0) return 1; else return 0;
}

/* Makeboundedtree() generates a bounded-degree tree of degree "graphtype" 
 * and "nodes" nodes rooted at node "root". */
makeboundedtree(root, nodes)
int root, nodes;
{
  int i, j, degree, edge;
  degree = graphtype;
  edge=0;
  for (i=1; i<=degree; ++i) {
    if (edge<nodes-1) {
      insert (root+i, root, 0, 1); 
      ++edge;
    }
  }
  for (j=1; j<=(nodes-1-degree)/(degree-1)+1; ++j) 
    for (i=1; i<=degree-1; ++i) {
      if (edge<nodes-1) 
	insert (root+degree+(j-1)*(degree-1)+i, root+j, 0, 1); 
      ++edge;
    }
}

/* Makecloud makes a cloud of "number" nodes, with edges of thresh 1. */
makecloud(start, number)
int start, number;
{
  int j, k, degree, edge;
  degree = graphtype;
  edge=0;
  for (k=1; k<=degree; ++k) {
    if (edge<number-1) {
      insert (start+k, start, 0, 1); 
      ++edge;
    }
  }
  for (j=1; j<=(cloudnum-1-degree)/(degree-1)+1; ++j) 
    for (k=1; k<=degree-1; ++k) {
      if (edge<number-1) {
	insert (start+degree+(j-1)*(degree-1)+k, start+j, 0, 1); 
        ++edge;
      }
    }
}

/* Pickbottom chooses the node in the cloud for the edge to the
 * k-th child cloud. */
int
pickbottom (k)
int k;
{
  int i, answer;
  float frac;
  if (threshtype==2) {
    frac = (float) random()/2147483647.0;
    answer = (int) (frac*(cloudnum-1));
  }
  else if (threshtype==3) {
    answer = 0;
    for (i=0; i<CLOUD; ++i) answer += power(graphtype, i);
    answer += (k-1)*power(graphtype, CLOUD-1); 
  }
  if (answer>cloudnum-1) abort();
  return answer;
}

/* Picktop chooses the offset for the node in the cloud for the edge to the
 * parent cloud. */
int 
picktop()
{
  int answer;
  float frac;
  if (threshtype==2) {
    frac = (float) random()/2147483647.0;
    answer = (int) (frac*(cloudnum-1));
  }
  else if (threshtype==3) answer = 0;
  if (answer>cloudnum-1) abort();
  return answer;
}



/* Makesecondlevel connects clouds with edges of thresh THRESH, 
 *  using "size" nodes starting with node "start".*/
makesecondlevel(start, size)
int start, size;
{
  int i, j, k, degree, edge, node1, node2, r1, r2, first, second;
  float frac;
  degree = graphtype;
  edge=0;
  for (k=1; k<=degree; ++k) {
    if (edge < (float) size/cloudnum-1) {
      r1 = pickbottom(k);  
      r2 = picktop();
      first = start+k*cloudnum+r2; if (first>N-1) first=N-1;
      second = start+r1;  if (second>N-1) second=N-1;
      insert (first, second, 0, THRESH); 
      ++edge;
    }
  }
  for (j=1; j<=(size/cloudnum-1-degree)/(degree-1)+1; ++j) {
    for (k=1; k<=degree-1; ++k) {
      if (edge<(float) size/cloudnum-1) {
	r1 = pickbottom(j);
	r2 = picktop(); 
	first = start+(degree+(j-1)*(degree-1)+k)*cloudnum+r2;
	if (first>N-1) first=N-1;
        second = start+j*cloudnum+r1;
	if (second>N-1) second=N-1;
	insert (first, second, 0, THRESH); 
        ++edge;
      }
    }
  }
}

/* Makethirdlevel connects second-level clouds with edges of thresh THRESH2, 
 *  using "size" nodes starting with node "start".*/
makethirdlevel(start, size)
int start, size;
{
  int j, k, degree, edge, node1, node2, r1, r2;
  float frac;
  degree = graphtype;
  edge=0;
  for (k=1; k<=degree; ++k) {
    if (edge < (float) size/(5*cloudnum)-1) {
      r1 = pickbottom(k);
      r2 = picktop(); 
      insert (start+k*(5*cloudnum)+r2, start+r1, 0, THRESH2); 
      ++edge;
    }
  }
  for (j=1; j<=(size/(5*cloudnum)-1-degree)/(degree-1)+1; ++j) {
    for (k=1; k<=degree-1; ++k) {
      if (edge<(float) size/(5*cloudnum)-1) {
	r1 = pickbottom(j);
	r2 = picktop(); 
	insert (start+(degree+(j-1)*(degree-1)+k)*(5*cloudnum)+r2, 
		start+j*(5*cloudnum)+r1, 0, THRESH2); 
        ++edge;
      }
    }
  }
}

/* Makestructuredtree() generates a structured bounded-degree tree,
 *  with edges of threshold 64 connecting clouds of
 *  cloudnum nodes each. */
makestructuredtree()
{
  int i, j, degree, edge, number;
  degree = graphtype;
  edge=0;
  for (i=0; i<N-1; i+=cloudnum) {
    number=cloudnum;  if (N-i<cloudnum) number=N-i;
    makecloud(i, number);
  }
  if (N>cloudnum) {
    for (i=0; i<N-1; i+=(5*cloudnum)) {
      number=(5*cloudnum);  if (N-i<(5*cloudnum)) number=N-i;
      makesecondlevel(i, number);
    }
  }
  if (N>(5*cloudnum))
    makethirdlevel(0, N);
}

/* Makemesh() makes a mesh of "number" nodes, with edges of
 * threshold THRESH. 
 */
makemesh(number)
int number;
{
  int i, row, col;
  for (i=1; i<=number; ++i) {
    if (i+ROW<=number) 
      insert((i-1)*cloudnum, (i+ROW-1)*cloudnum, 0, THRESH);
    if (i+1<=number && i%ROW!=0) 
      insert((i-1)*cloudnum, i*cloudnum, 0, THRESH);
  }
}

/* Makemeshtree() generated a mesh of Ceiling(N/cloudnum) nodes, each
 * the root of a cloud of cloudnum nodes.  Edges in the mesh have
 * threshold THRESH.  Edges in the clouds have threshold 1. 
 */
makemeshtree()
{
  int i, meshnodes, start;
  meshnodes = (int) ceil((double) ((double)N/cloudnum));
  makemesh(meshnodes);
  for (i=0; i<N-cloudnum; i+=cloudnum) {
    if (verbose4==1) printf ("Start: %d number: %d\n", i, cloudnum);
    makeboundedtree(i, cloudnum);
  }
  start = (meshnodes-1)*cloudnum;
  if (verbose4==1) printf ("Start: %d number: %d\n", start, N-start);
  makeboundedtree(start, N - start);
}

/* Maketree randomly generates a tree. */
maketree()
{
  int i, j, k, marker, first, second, edges, smallest_end, prufer; 
  int top_end, oldk;
  float frac;
  struct end_vertex {
	int v;			/* Nodes, from 0 to N-1 */
	int next;    		/* Index of next element in list. */
  } ; 
  struct end_vertex EndList[N];
  int Prufer[N-2];		/* Prufer sequence for generating graph */
  int count[N];		        /* the number of occurences of this node
				 * in Prufer */
  for (i=0; i<N; ++i) count[i]=0;
  prufer=0;
  for (i=0; i<N-2; ++i) {
	/* Choose j uniformly from 0 to N-1. */
	frac = (float) random()/2147483647.0;
	j=((int) (frac*N))%N;
	Prufer[i]=j;
	++count[j];
  }
  top_end = 1;
  for (i=0; i<N; ++i)
	if (count[i]==0) {
	  EndList[top_end].v=i;
	  EndList[top_end].next=top_end+1;
	  ++top_end;
	}
  EndList[0].v=-1;
  EndList[top_end-1].next = 0;
  smallest_end=1; 
  edges=0;
  while (edges < N-2) {
          first = EndList[smallest_end].v;
	  smallest_end = EndList[smallest_end].next;
          second =  Prufer[prufer++];
          if (--count[second] == 0) {
	    if (EndList[smallest_end].v==-1) {
	      EndList[top_end].v=second;
	      EndList[top_end].next=0;
	      smallest_end=top_end;
	      ++top_end;
	    }
	    else if (EndList[smallest_end].v > second) {
	      EndList[top_end].v=second;
	      EndList[top_end].next=smallest_end;
	      smallest_end=top_end;
	      ++top_end;
	    }
	    else {
              k=smallest_end;
              while (EndList[k].v < second && EndList[k].v!=-1) 
  		{  oldk=k; k=EndList[k].next; }
  	      EndList[oldk].next = top_end;
  	      EndList[top_end].v=second;
  	      EndList[top_end].next=k;
  	      ++top_end;
  	    }
	  }
          insert (first, second, 0, 1); ++edges;
	  /*
          printf ("Prufer: ");
	  for (i=prufer; i<N-2; ++i) printf ("%d ", Prufer[i]);
	  printf ("\n");
          printf ("EndList: ");
	  for (i=smallest_end; EndList[i].v!=-1; i=EndList[i].next) 
	     printf ("%d ",  EndList[i].v);
	  printf ("\n");
	  */
  }
  first = EndList[smallest_end].v;
  smallest_end = EndList[smallest_end].next;
  second =  EndList[smallest_end].v;
  insert (first, second, 0, 1);
  /* This is the old version. 
  for (i=1; i<N; ++i) {
	Choose j uniformly from 0 to i-1. 
	frac = (float) random()/2147483647.0;
        j=((int) (frac*i))%i;
	insert(i, j, 0, 1);
  }
  */
}

/* Makegraph randomly generates a graph.  First a spanning tree is
 * generated, and then random edges are added.
 */
makegraphlst()
{
  int i, j, k, edges;
  float frac;
  struct node *t, *z;
  if (graphtype==0) {
    maketree();
    printf ("Tree: random\n");
  }
  else if (threshtype<=1) {
    printf ("Tree: bounded-degree, degree: %d\n", graphtype);
    makeboundedtree(0, N);
  }
  else if (threshtype==2||threshtype==3) {
    printf ("Tree: structured, degree: %d cloudsize: %d thresholds: %d %d\n", 
       graphtype, cloudnum, THRESH, THRESH2);
    makestructuredtree();
  }
  else if (threshtype==4) {
    printf ("Tree: mesh, degree: %d cloudsize: %d threshold: %d\n", 
       graphtype, cloudnum, THRESH);
    makemeshtree();
  }

  edges=N-1;
  if (verbose4==1) printgraph();
  while (edges < M) {
    frac = (float) random()/2147483647.0;
    i=((int) (frac*N))%N;
    if (inserttype==-1) {
    	frac = (float) random()/2147483647.0;
    	j=((int) (frac*N))%N;
    }
    else j=finddistance(i);
    if (lengthtype==0) addedge.length=0;
    if (i!=j && edge(i, j)==0) {
      insert(i, j, addedge.length, 1);
      if (verbose4==1) printf ("New edge: %d %d\n", i, j);
      ++edges;
    }
  }
}

