#include "repairs.h"

/* Visit repeatedly visits the "closest" vertex, and inserts
 *  neighbor vertices in the priority queue. */

visit()
{ 
  int k; 
  struct node *t;
  while (!pqempty()){
    k = pqremove(); 
    if (adj[k] != z)
     for (t = adj[k]; t != z; t = t->next)
      if (pqdistance(t->v) < 0) {
        (pqupdate(t->v, -(pqdistance(k)+t->length), k)); 
      }
  }
}

/* Listpfs computes the shortest path tree from "source". */
/* "Negative" distances are for nodes whose distances have not finally
 * been determined. */
listpfs(source)
int source;
{
  int k;
  struct node *neighbor = adj[source];
  pqinitialize(source);
  while (neighbor != z) {
    	pqinsert(neighbor->v, -(neighbor->length), source);
    	neighbor = neighbor->next;
  }
  visit();
}  

/* Visitdist repeatedly visits the "closest" vertex, and inserts
 *  neighbor vertices in the priority queue, until all vertices of
 * distance "dist1" is found. */
visitdist(dist1)
int dist1;
{ 
  int k, done=0, answer=0; 
  struct node *t;
  while (!pqempty()&&done==0){
    k = pqremove(); 
    for (t = adj[k]; t != z; t = t->next)
      if (pqdistance(t->v) < 0)
        if (pqupdate(t->v, -(pqdistance(k)+t->length), k)) {
	  if (pqdistance(k)+t->length>dist1) {
		done==1;
	  }
        }
  }
}

/* Finddistance finds a random node of distance in hops of "inserttype" 
 * from "source". */
int
finddistance(source)
int source;
{
  int i, k, found=0, answer, maxdist, candidate[N];
  float frac;
  struct node *neighbor = adj[source];
  /*
  pqinitialize();
  */
  pqinitialize(source);
  while (neighbor != z) {
    pqinsert(neighbor->v, -(neighbor->length), source);
    neighbor = neighbor->next;
  } 
  visitdist(inserttype);
  for (k=1; k<N; ++k) candidate[k]= -1;
  k=0;
  for (i=1; i<N; ++i) 
    /* find all nodes at hops distance "maxdist" */
    if (pqhops(i)==inserttype) {
      candidate[k]=i;
      ++k;
    }
  frac = (float) random()/2147483647.0;
  answer = (int) (frac*(k-1));
  addedge.first=source;
  addedge.second = answer;
  /* This is not done yet. */
  addedge.length = pqdistance(answer);
  return candidate[answer];
}

/* Linkthresh reports the threshold on the link (first, second) */
int
linkthresh(first, second)
int first, second;
{
  int thresh=-1;
  struct node *t = adj[first];
  while (thresh==-1 && t != z) {
    if (t->v==second) {
      thresh = t->thresh;
      /*
      printf ("first: %d second: %d thresh: %d\n", first, second, thresh);
      */
    }
    else t = t->next;
  }
  return thresh;
}

