#include "repairs.h"
#define COLUMNS1 5

/* Printgraph prints the adjacency matrix. */
printgraph() 
{
  int i, edgenos;
  struct node *t;
  edgenos=0;
  printf ("Graph, adjacency list:\n");
  for (i=0; i<N; ++i) {  
      printf ("%d: ", i);
      for (t = adj[i]; t != z; t = t->next) {
        printf ("%d(%d,%d) ", t->v, t->length, t->thresh);
	++edgenos;
      }
  printf ("\n");
  }
  if (edgenos != 2*M) 
    printf ("Error: printgraph, seed %d, M: %d, edgenos: %d\n",
      seed, M, edgenos);
}

/* Printgroup prints the members of the whiteboard session. */
printgroup()
{
  int i, row;
  printf ("Number of ethernet nodes attached to each router: %d\n",
    ETHER);
  printf ("Session members: ");
  /*
  for (i=0; i<G; ++i) {
    printf ("%d  ", Member[i].wbnode);
    if (i%COLUMNS==COLUMNS-1) printf ("\n");
  }
  */
  row=0;
  for (i=0; i<N; ++i) 
    if (wb[i]==1) {
      printf ("%d  ", i);
      ++row;
      if (row%COLUMNS==COLUMNS-1) printf ("\n");
    }
  printf ("\n");
}

printsource(num)
int num;
{
  if (num>=0 && num<ERRORS)
    printf ("Source: %d\n", source[num]);
}

printdist(nodeno, dist, parentno)
int nodeno, dist, parentno;
{
  printf ("  ");
  if (wb[nodeno]==1) printf ("*");
  printf ("%d: %d (%d) ", nodeno, parentno, dist);
}

/* Used in printing the shortest path tree. */
printparent(nodeno, parentno)
int nodeno, parentno;
{
  printf ("    ");
  if (wb[nodeno]==1) printf ("*");
  printf ("%d: %d ", nodeno, parentno);
} 

/* To print the shortest path tree, up to "level" levels. */
printval(levels)
int levels;
{ 
  int i, j, num, depth, top;
  if (levels==0) depth=N; else depth=levels;
  printf ("Shortest path tree.   Node: parent (distance): \n");
  top=3; if (depth<3) top=depth;
  for (j=0; j<=top; ++j) {
    for (i=0; i<N; ++i)
      if (pqdistance(i)==j) printparent(i, pqparent(i));
    printf ("\n");
  }
  num=0;
  top=8; if (depth<8) top=depth;
  for (j=4; j<=top; ++j) {
    for (i=0; i<N; ++i)
      if (pqdistance(i)==j) {
        printdist(i, pqdistance(i), pqparent(i)); 
        if (num%COLUMNS1==COLUMNS1-1) printf ("\n");
        ++num;
      } 
  }
  if (depth > 8) for (i=0; i<N; ++i) {
    if (pqdistance(i)>8&&pqdistance(i)<=depth) {
      printdist(i, pqdistance(i), pqparent(i));
      if (num%COLUMNS1==COLUMNS1-1) printf ("\n");
      ++num;
    }
  }
  printf ("\n");
}

/* Prints the chosen bad edge. */
printbadedge(num)
int num;
{ 
  if (num>=0 && num<ERRORS)
    printf ("Bad edge: (%d, %d)\n", badedge[num].first,
badedge[num].second);
}   

/* Prints the bad nodes. */
printbadnodes(errornum)
int errornum;
{
  int i, count=0;
  if (verbose5==1) printf ("Bad wb nodes: ");
  for (i=0; i<G; i+=1) 
    if (Member[i].wbstatus[errornum]==BAD) {
      if (verbose5==1) printf ("%d ", Member[i].wbnode);
      ++count;
    }
  if (verbose5==1) printf ("\n");
  printf ("Error num: %d Number of bad nodes: %d\n", errornum, count);
}

printwb(errornum)
int errornum;
{
  int i;
  for (i=0; i<G; i+=ETHER) 
    printf ("Session node: %d, status: %d\n", Member[i].wbnode, 
      Member[i].wbstatus[errornum]);
}

printnacktimes()
{
  int i;
  for (i=0; i<G; i+=1)
    if (Member[i].wbstatus[errornum]==BAD &&
	(rep_to_save==0||rep_to_save==round)) {
      printf ("Event: node %d time: %6.3f set NTIMER for %6.3f",
	      Member[i].wbnode, Member[i].disttosource[errornum], 
		Member[i].wbtimer);
      if (ETHER > 1) printf (" ether: %d", i%ETHER);
      printf ("\n");
    }
}

printtype(type)
int type;
{
  if (type==0) printf ("REPAIR");  
  if (type==1) printf ("NACK");   
  if (type==2) printf ("RTIMER");      
  if (type==3) printf ("NTIMER");
}

printresponse(v)
int v;
{
  if (Member[v].wbstatus[errornum]==BAD) printf ("NTIMER");
    else printf ("RTIMER");
} 

printpackets(type)
int type;
{
  if (type==2) printf ("REPAIRs");
  if (type==3) printf ("NACKs");
}

printdisttosource(errornum)
int errornum;
{
  int i;
  for (i=0; i<G; i+=ETHER)
    if (Member[i].disttosource[errornum]>=0)
      printf ("Node: %d  disttosource: %6.3f\n", 
	Member[i].wbnode, Member[i].disttosource[errornum]);
}
